/*
 * Copyright (c) 2000 Ping Pan and Columbia University
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by Columbia University
 * and its contributors.'' Neither the name of the University nor the names 
 * of its contributors may be used to endorse or promote products derived 
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <sys/param.h>
#include <sys/protosw.h>
#include <sys/domain.h>
#include <sys/socket.h>
#include <sys/socketvar.h>
#include <sys/kernel.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netipopt/ipopt_var.h>


static struct pr_usrreqs nousrreqs;

/* don't move the first entry, check ipopt_reg_proto()
 */
struct protosw	ipoptsw[] = {
{ 0,		&ipoptdomain,	0,		PR_ATOMIC|PR_ADDR,
  null_input,	0,		0,		0,
  0,
  0,		0,		0,		0,
  &nousrreqs
},
{ SOCK_RAW,	&ipoptdomain,	IPOPT_RA,	PR_ATOMIC|PR_ADDR,
  ra_input,	0,		0,		ipopt_ctloutput,
  0,
  0,		0,		0,		0,
  &ipopt_usrreqs
},
{ SOCK_RAW,	&ipoptdomain,	IPOPT_RR,	PR_ATOMIC|PR_ADDR,
  rr_input,	0,		0,		ipopt_ctloutput,
  0,
  0,		0,		0,		0,
  &ipopt_usrreqs
},
{ SOCK_RAW,	&ipoptdomain,	IPOPT_TS,	PR_ATOMIC|PR_ADDR,
  ts_input,	0,		0,		ipopt_ctloutput,
  0,
  0,		0,		0,		0,
  &ipopt_usrreqs
},
{ SOCK_RAW,	&ipoptdomain,	IPOPT_SECURITY,	PR_ATOMIC|PR_ADDR,
  security_input,	0,		0,		ipopt_ctloutput,
  0,
  0,		0,		0,		0,
  &ipopt_usrreqs
},
{ SOCK_RAW,	&ipoptdomain,	IPOPT_LSRR,	PR_ATOMIC|PR_ADDR,
  lsrr_input,	0,		0,		ipopt_ctloutput,
  0,
  0,		0,		0,		0,
  &ipopt_usrreqs
},
{ SOCK_RAW,	&ipoptdomain,	IPOPT_SSRR,	PR_ATOMIC|PR_ADDR,
  ssrr_input,	0,		0,		ipopt_ctloutput,
  0,
  0,		0,		0,		0,
  &ipopt_usrreqs
},
};


static struct domain 	ipoptdomain = {
	AF_IPOPTION,	"ip-option",	ipopt_init,	0,	0,
	ipoptsw, &ipoptsw[sizeof(ipoptsw)/sizeof(ipoptsw[0])],	0,
	0,	0,	0};

DOMAIN_SET(ipopt);

